#!/bin/bash
if [ -z "$KEY" ]; then
    echo "Fallback to default key: ~/.ssh/id_rsa"
    KEY=~/.ssh/id_rsa
fi
if [ ! -f "$KEY" ]; then
    echo "The specified private key file '$KEY' does not exist."
    exit 1
fi
if [ ! -f "$KEY.pub" ]; then
    echo "The public key file '$KEY.pub' does not exist."
    exit 1
fi

AUTHORIZED_KEYS=$(cat "$KEY.pub")

echo "You can connect to the container with the following command:"
echo "  ssh -p2222 -i $KEY user@localhost"
echo ""

docker run -p 127.0.0.1:2222:2222 -e AUTHORIZED_KEYS="$AUTHORIZED_KEYS" $@ --rm escape-the-shell
