import os

from game.model import GameTask
from game.utility import bcolors

GAME_TASK_LIST = []


# Aufgabe 1: Fahrkarte bewegen
def task_1_solution(username) -> bool:
    return os.path.exists("/home/{}/Fahrkarte".format(username))


GAME_TASK_LIST.append(
    GameTask(
        task_1_solution,
        f"- Gucke dich mit {bcolors.BOLD}ls{bcolors.ENDC} in dem aktuellen Ordner um.\n"
        "- Lies die Datei Notiz.md.\n"
        "- Bewege deine Fahrkarte aus der Tasche.\n",
        f"- Mit {bcolors.BOLD}ls{bcolors.ENDC} kannst du dir den Inhalt eines Ordners anzeigen lassen.\n"
        f"- Mit {bcolors.BOLD}cat <Datei>{bcolors.ENDC} kannst du dir den Inhalt einer Datei anzeigen lassen.\n"
        f"- Mit {bcolors.BOLD}mv <original> <ziel>{bcolors.ENDC} kannst du eine Datei bewegen.\n",
        task_dialog="Schaffner: Hey du... Na bist du endlich aufgewacht?\n"
        "Schaffner: Hast du eine Ahnung wo du bist? Was steht da eigentlich auf dem Zettel?\n"
        "Schaffner: Ich muesste dann auch noch mal deine Fahrkarte sehen. Kannst du die bitte aus deiner Tasche holen?",
    )
)


# Aufgabe 2: cp, wildcard
def task_2_solution(username) -> bool:
    d = list()
    d.append("FahrplanAppelstrasse.md")
    d.append("Geheimplan.txt")
    d.append("MiiLobbyAppelstrasse.mp3")
    d.append("WieTrinkeIchBierRichtig.txt")
    c = 0
    if os.path.exists("/home/{}/Auslage".format(username)):
        for n in os.listdir("/home/{}/Auslage".format(username)):
            if n in d:
                c += 1
        if c == len(d):
            return True
    return False


GAME_TASK_LIST.append(
    GameTask(
        task_2_solution,
        "- Kopiere alle Textdatein (.txt) und Dateien, die 'Appelstrasse' im Namen haben, aus dem Ornder 'Kiste' in den Ordner 'Auslage'.",
        f"- Mit dem Befehl {bcolors.BOLD}cp <original> <ziel>{bcolors.ENDC} kannst du eine Datei kopieren.\n"
        f"- Ein {bcolors.BOLD}*{bcolors.ENDC} im Dateinamen dient als Wildcard",
        task_dialog="Schaffner: Ah deine Fahrkarte ist gueltig...\n"
        "Schaffner: Ich habe gehoert du bist einer dieser Computer-Magie-Lehrlinge...\n"
        "Schaffner: Kannst du mir bei einem Problem helfen? Kannst du alle Fahrplaene, die auf .txt enden oder Appelstrasse\n"
        "im Namen haben aus der Kiste dort drueber in die Auslage kopieren?",
    )
)


# Aufgabe 3: grep
def task_3_solution(username) -> bool:
    path = "/home/{}/key.txt".format(username)
    if os.path.exists(path):
        f = open(path, "r")
        content = f.read()
        f.close()
        return "tce_abc_123" in content
    return False


GAME_TASK_LIST.append(
    GameTask(
        task_3_solution,
        "- Benutze grep um die Datei mit der Zeichenkette Schluessel zu finden.\n"
        f"- {bcolors.BOLD}mv{bcolors.ENDC} oder {bcolors.BOLD}cp{bcolors.ENDC} die Datei in dein Home.\n",
        f"- {bcolors.BOLD}grep <datei>{bcolors.ENDC} durchsucht die Datei nach einer Zeichenkette und gibt den Dateinamen zurueck."
        f"- Du kannst auch {bcolors.BOLD}man grep{bcolors.ENDC} fuer mehr Informationen ausprobieren. Eine MAN-Page verlaesst man mit {bcolors.BOLD}q{bcolors.ENDC}.",
        task_dialog="Schaffner: Ah super vielen Dank... Ich haette dafuer Tage gebraucht.\n"
        "Schaffner: Du hast ja echt was drauf, kannst du mir auch helfen meinen Schluessel wieder zu finden?\n"
        "Schaffner: Ich weiss nur noch das er irgendwo in der Kiste dort drueber war.\n",
    )
)


# Aufgabe 4: nano, feedback
def task_4_solution(username) -> bool:
    path = "/home/{}/feedback".format(username)
    if os.path.exists(path):
        f = open(path, "r")
        content = f.read()
        f.close()
        return len(content) > 0
    return False


GAME_TASK_LIST.append(
    GameTask(
        task_4_solution,
        "- Schreibe deine Meinung zum Workshop in die Datei feedback in deinem Home.\n"
        f"- Benutze dafuer {bcolors.BOLD}nano <Dateiname>{bcolors.ENDC} um die Datei zu erstellen, bearbeiten und zu speichern.\n"
        f"{bcolors.FAIL}-> Das Feedback ist natuerlich anonym :){bcolors.ENDC}",
        "- nano ist ein Texteditor fuer das Terminal.\n"
        f"- Mit {bcolors.BOLD}nano feddback{bcolors.ENDC} kannst du die gewuenschte Datei erstellen.\n"
        "- Achte auf den Dialog im Editor, wenn du speichern moechtest.\n",
        task_dialog="Schaffner: Ah das ist mein Schluessel. Du bist ja echt genial...\n"
        "Schaffner: Gut das du ihn gefunden hast, sonst haette ich dir nicht die Tuer aufschliessen koennen.\n"
        "Schaffner: Wir kommen naemlich gleich am Bahnhof Nordstadt an,\n"
        "magst du mir bevor du aussteigst noch sagen wie du die Zugfahrt fandest?\n",
    )
)

GAME_TASK_LIST.append(None)
